OpenCL C++ Bindings

Loading...
Searching...
No Matches
cl::Image Class Reference

C++ base class for Image Memory objects. More...

`#include <opencl.hpp>`

Inheritance diagram for cl::Image:

## Public Member Functions
template<typename T>
cl_int | getImageInfo (cl_image_info name, T *param) const
| Wrapper for clGetImageInfo().
template<cl_image_info name>
detail::param_traits< detail::cl_image_info, name >::param_type | getImageInfo (cl_int *err=nullptr) const
| Wrapper for clGetImageInfo() that returns by value.
Public Member Functions inherited from cl::Memory
| Memory ()
| Default constructor - initializes to nullptr.
| Memory (const cl_mem &memory, bool retainObject)
| Constructor from cl_mem - takes ownership.
Memory & | operator= (const cl_mem &rhs)
| Assignment operator from cl_mem - takes ownership.
template<typename T>
cl_int | getInfo (cl_mem_info name, T *param) const
| Wrapper for clGetMemObjectInfo().
template<cl_mem_info name>
detail::param_traits< detail::cl_mem_info, name >::param_type | getInfo (cl_int *err=nullptr) const
| Wrapper for clGetMemObjectInfo() that returns by value.
cl_int | setDestructorCallback (void(CL_CALLBACK *pfn_notify)(cl_mem, void *), void *user_data=nullptr)
| Registers a callback function to be called when the memory object is no longer needed.
Public Member Functions inherited from cl::detail::Wrapper< cl_mem >
Wrapper< cl_type > & | operator= (const Wrapper< cl_type > &rhs)
const cl_type & | operator() () const
cl_type | get () const

## Protected Member Functions
| Image ()
| Default constructor - initializes to nullptr.
| Image (const cl_mem &image, bool retainObject=false)
| Constructor from cl_mem - takes ownership.
Image & | operator= (const cl_mem &rhs)
| Assignment from cl_mem - performs shallow copy.
Protected Member Functions inherited from cl::detail::Wrapper< cl_mem >
cl_int | retain () const
cl_int | release () const

## Additional Inherited Members
Public Types inherited from cl::detail::Wrapper< cl_mem >
typedef cl_mem | cl_type
Protected Attributes inherited from cl::detail::Wrapper< cl_mem >
cl_type | object_

## Detailed Description

C++ base class for Image Memory objects.

See Memory for details about copy semantics, etc.

See also
  Memory

Definition at line 4811 of file opencl.hpp.

## Constructor & Destructor Documentation

## ◆ Image() [1/2]

cl::Image::Image | ( |  | ) |
| inline protected

Default constructor - initializes to nullptr.

Definition at line 4815 of file opencl.hpp.

## ◆ Image() [2/2]

cl::Image::Image | ( | const cl_mem & | image,
|  | bool | retainObject = false )
| inline explicit protected

Constructor from cl_mem - takes ownership.

Parameters

  retainObject | will cause the constructor to retain its cl object. Defaults to false to maintain compatibility with earlier versions. See Memory for further details.

Definition at line 4824 of file opencl.hpp.

## Member Function Documentation

## ◆ getImageInfo() [1/2]

template<typename T>

cl_int cl::Image::getImageInfo | ( | cl_image_info | name,
|  | T * | param ) const
| inline

Wrapper for clGetImageInfo().

Definition at line 4841 of file opencl.hpp.

## ◆ getImageInfo() [2/2]

template<cl_image_info name>

detail::param_traits< detail::cl_image_info, name >::param_type cl::Image::getImageInfo | ( | cl_int * | err = nullptr | ) | const
| inline

Wrapper for clGetImageInfo() that returns by value.

Definition at line 4851 of file opencl.hpp.

## ◆ operator=()

Image & cl::Image::operator= | ( | const cl_mem & | rhs | ) |
| inline protected

Assignment from cl_mem - performs shallow copy.

See Memory for further details.

Definition at line 4831 of file opencl.hpp.

The documentation for this class was generated from the following file:

- opencl.hpp